'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var objectEquals = exports.objectEquals = function objectEquals(object1, object2) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var currentDepth = 0;
  var depth = options.depth || 100000;
  var keysOnly = options.keysOnly || false;
  var valuesOnly = options.valuesOnly || false;
  return objectEqualsUtil(object1, object2, {
    depth: depth, currentDepth: currentDepth, keysOnly: keysOnly, valuesOnly: valuesOnly
  });
};

var objectEqualsUtil = function objectEqualsUtil(object1, object2, _ref) {
  var depth = _ref.depth,
      currentDepth = _ref.currentDepth,
      keysOnly = _ref.keysOnly,
      valuesOnly = _ref.valuesOnly;

  if (!object1 || !object2 || (typeof object1 === 'undefined' ? 'undefined' : _typeof(object1)) !== 'object' || (typeof object2 === 'undefined' ? 'undefined' : _typeof(object2)) !== 'object') {
    return object1 === object2;
  }
  if (currentDepth >= depth) {
    return true;
  }
  currentDepth += 1;
  var entries1 = Object.entries(object1);
  var entries2 = Object.entries(object2);
  if (entries1.length !== entries2.length) {
    return false;
  }
  for (var index = 0; index < entries1.length; index += 1) {
    if (entries1[index][0] !== entries2[index][0] && !valuesOnly) {
      return false;
    }
    var valueComparison = objectEqualsUtil(entries1[index][1], entries2[index][1], { depth: depth, currentDepth: currentDepth, keysOnly: keysOnly, valuesOnly: valuesOnly });
    if (!valueComparison && !keysOnly) {
      return false;
    }
  }
  return true;
};